/*
 * Xfred.h
 *
 * Main header file for the library Xfred.a. Mostly just includes the
 * header files for the various parts, but also defines a union-type
 * thing for generic visual manipulation.
 *
 * 
 *
 */

#ifndef BLACK
#define BLACK(d) BlackPixel(d, DefaultScreen(d))
#endif

#ifndef WHITE
#define WHITE(d) WhitePixel(d, DefaultScreen(d))
#endif

#ifndef _XF_XFRED_H
#define _XF_XFRED_H

#include <stdio.h>
#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "Callback.h"
#include "VisInfo.h"
#include "Button.h"


/*
 * This incredibly unelegant macro allows for freeing up memory that
 * has been slaved to a linked list.
 */

#define FreeList(type, head, next) \
{ \
  type n; \
  type m; \
  n = head; \
  while (n != NULL) \
    { \
      m = n->next; \
      free(n); \
      n = m; \
    } \
}


#endif /* _XF_XFRED_H */
